From 2306550ad20971f389cc6f10c353cc8f1ae68662 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 16 2020 02:08:10 +0000
Subject: [PATCH 1419/2232] Merge pull request #475 from dtolnay/unpin


Enforce no explicit Unpin impl on an opaque C++ type
---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 94c5696..beb5e62 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -47,6 +47,7 @@ fn expand(ffi: Module, apis: &[Api], types: &Types) -> TokenStream {
                 let ident = &ety.name.rust;
                 if !types.structs.contains_key(ident) && !types.enums.contains_key(ident) {
                     expanded.extend(expand_cxx_type(ety));
+                    hidden.extend(expand_cxx_type_assert_pinned(ety));
                 }
             }
             Api::CxxFunction(efn) => {
@@ -204,6 +205,33 @@ fn expand_cxx_type(ety: &ExternType) -> TokenStream {
     }
 }
 
+fn expand_cxx_type_assert_pinned(ety: &ExternType) -> TokenStream {
+    let ident = &ety.name.rust;
+    let infer = Token![_](ident.span());
+
+    quote! {
+        let _ = {
+            // Derived from https://github.com/nvzqz/static-assertions-rs.
+            trait __AmbiguousIfImpl<A> {
+                fn infer() {}
+            }
+
+            impl<T: ?Sized> __AmbiguousIfImpl<()> for T {}
+
+            #[allow(dead_code)]
+            struct __Invalid;
+
+            impl<T: ?Sized + Unpin> __AmbiguousIfImpl<__Invalid> for T {}
+
+            // If there is only one specialized trait impl, type inference with
+            // `_` can be resolved and this can compile. Fails to compile if
+            // user has added a manual Unpin impl for their opaque C++ type as
+            // then `__AmbiguousIfImpl<__Invalid>` also exists.
+            <#ident as __AmbiguousIfImpl<#infer>>::infer
+        };
+    }
+}
+
 fn expand_cxx_function_decl(efn: &ExternFn, types: &Types) -> TokenStream {
     let receiver = efn.receiver.iter().map(|receiver| {
         let receiver_type = receiver.ty();
diff --git a/tests/ui/unpin_impl.rs b/tests/ui/unpin_impl.rs
new file mode 100644
index 0000000..e10cc72
--- /dev/null
+++ b/tests/ui/unpin_impl.rs
@@ -0,0 +1,12 @@
+use std::marker::Unpin;
+
+#[cxx::bridge]
+mod ffi {
+    extern "C++" {
+        type Opaque;
+    }
+}
+
+impl Unpin for ffi::Opaque {}
+
+fn main() {}
diff --git a/tests/ui/unpin_impl.stderr b/tests/ui/unpin_impl.stderr
new file mode 100644
index 0000000..37e4f9d
--- /dev/null
+++ b/tests/ui/unpin_impl.stderr
@@ -0,0 +1,8 @@
+error[E0282]: type annotations needed for `fn()`
+ --> $DIR/unpin_impl.rs:6:14
+  |
+3 | #[cxx::bridge]
+  | -------------- consider giving this pattern the explicit type `fn()`, with the type parameters specified
+...
+6 |         type Opaque;
+  |              ^^^^^^ cannot infer type

